VERSION 5.00
Begin VB.UserControl MatrixLabel 
   BackColor       =   &H00000000&
   BackStyle       =   0  '
   ClientHeight    =   6000
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   270
   BeginProperty Font 
      Name            =   "lr "
      Size            =   18
      Charset         =   128
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   ScaleHeight     =   6000
   ScaleWidth      =   270
   Begin VB.Label lbl 
      AutoSize        =   -1  'True
      BackStyle       =   0  '
      Caption         =   "1"
      ForeColor       =   &H00036B09&
      Height          =   360
      Index           =   1
      Left            =   0
      TabIndex        =   1
      Top             =   60
      Width           =   195
   End
   Begin VB.Label lbl 
      BackColor       =   &H00000000&
      Caption         =   "1"
      ForeColor       =   &H0064FF64&
      Height          =   360
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   5520
      Width           =   195
   End
End
Attribute VB_Name = "MatrixLabel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim mbyt        As Byte
Dim mPosition   As Integer

Dim mFontSize As Integer
Dim mFontName As String
Dim mTextsLength As Integer
Dim mTexts As String
Dim mScrollTexts As String

Private Const mcDEF_FontSize = 12
Private Const mcDEF_FontName = "lr "
Private Const mcDEF_TextsLength = 20
Private Const mcDEF_Texts = "12345678901234567890"

'***************************************************
' tHgTCYݒpvpeB
Public Property Let FontSize(pFontSize As Integer)
    mFontSize = pFontSize
    PropertyChanged "FontSize"
    Call Refresh_Control
End Property

' tHgTCY擾pvpeB
Public Property Get FontSize() As Integer
    FontSize = mFontSize
End Property

'***************************************************
' tHgݒpvpeB
Public Property Let FontName(pFontName As String)
    mFontName = pFontName
    PropertyChanged "FontName"
    Call Refresh_Control
End Property

' tHg擾pvpeB
Public Property Get FontName() As String
    FontName = mFontName
End Property

'***************************************************
' ݒpvpeB
Public Property Let TextsLength(pTextsLength As Integer)
    If pTextsLength <= 0 Then
        MsgBox "abnormal value", vbExclamation + vbOKOnly, "Matrix Label"
        Exit Property
    End If
    mTextsLength = pTextsLength
    PropertyChanged "TextsLength"
    Call Refresh_Control
End Property

' 擾pvpeB
Public Property Get TextsLength() As Integer
    TextsLength = mTextsLength
End Property

'***************************************************
' ݒpvpeB
Public Property Let Texts(pTexts As String)
    If pTexts = "" Then
        MsgBox "abnormal value", vbExclamation + vbOKOnly, "Matrix Label"
        Exit Property
    End If
    mTexts = pTexts
    PropertyChanged "Texts"
    Call Refresh_Control
End Property

' 擾pvpeB
Public Property Get Texts() As String
    Texts = mTexts
End Property

'***************************************************
Private Sub UserControl_InitProperties()
    
    mPosition = 1
    mFontSize = mcDEF_FontSize
    mFontName = mcDEF_FontName
    mTextsLength = mcDEF_TextsLength
    mTexts = mcDEF_Texts
    
    lbl(0).BackColor = vbBlack
    lbl(1).BackColor = vbBlack
'    lbl(0).ForeColor = &H46209
'    lbl(1).ForeColor = &HFF00&
    lbl(0).ForeColor = &H64FF64
    lbl(1).ForeColor = &H36B09
    UserControl.BackColor = vbBlack
    
    Call Refresh_Control
    
End Sub

'***************************************************
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    
    mFontSize = PropBag.ReadProperty("FontSize", mcDEF_FontSize)
    mFontName = PropBag.ReadProperty("FontName", mcDEF_FontName)
    mTextsLength = PropBag.ReadProperty("TextsLength", mcDEF_TextsLength)
    mTexts = PropBag.ReadProperty("Texts", mcDEF_Texts)
    
    Call Refresh_Control

End Sub

'***************************************************
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("FontSize", mFontSize, mcDEF_FontSize)
    Call PropBag.WriteProperty("FontName", mFontName, mcDEF_FontName)
    Call PropBag.WriteProperty("TextsLength", mTextsLength, mcDEF_TextsLength)
    Call PropBag.WriteProperty("Texts", mTexts, mcDEF_Texts)
    
    Call Refresh_Control
    
End Sub

'***************************************************
Private Sub UserControl_Resize()

    UserControl.Height = lbl(0).Height + lbl(1).Height
    UserControl.Width = lbl(0).Width

End Sub

'***************************************************
Private Sub Refresh_Control()

    Dim lngSize(1) As Long
    Dim i%
    Dim strTmp$
    
    mScrollTexts = mTexts
    
    Do Until Len(mScrollTexts) >= mTextsLength
        mScrollTexts = mScrollTexts & mTexts
    Loop
    
    With lbl(1)
        .FontSize = mFontSize
        .FontName = mFontName
        For i = 0 To mTextsLength - 2
            strTmp$ = strTmp$ & Mid(mScrollTexts, i + 1, 1) & vbCrLf
        Next i
        .Caption = strTmp$
    End With

    With lbl(0)
        .FontSize = mFontSize
        .FontName = mFontName
        
        .AutoSize = True
        lngSize(0) = 0
        lngSize(1) = 0
        For i = 1 To Len(mTexts)
            .Caption = Mid(mTexts, i, 1)
            If .Height > lngSize(0) Then
                lngSize(0) = .Height
            End If
            If .Width > lngSize(1) Then
                lngSize(1) = .Width
            End If
        Next i
        .AutoSize = False
        .Height = lngSize(0)
        .Width = lngSize(1)
        
        .Top = lbl(1).Top + lbl(1).Height - (mFontSize * 10 + 100)
    
    End With

    
    UserControl.Height = lbl(0).Height + lbl(1).Height
    UserControl.Width = lbl(0).Width
    

End Sub

'***************************************************
Public Sub Scroll_Texts()
    
    Dim strTmp$
    Dim i%
    
    
    If mbyt = 0 Then
'        lbl(0).BackColor = &HFF00&
        lbl(0).BackColor = &H64FF64
        mbyt = 1
    Else
        lbl(0).BackColor = vbBlack
        mbyt = 0
    End If
        
    If mPosition >= Len(mScrollTexts) Then
        mPosition = 1
    Else
        mPosition = mPosition + 1
    End If
        
    lbl(0).Caption = Mid(mScrollTexts & mScrollTexts, mPosition, 1)
    For i = mPosition + 1 To mPosition + mTextsLength - 1
        strTmp$ = strTmp$ & Mid(mScrollTexts & mScrollTexts, i, 1) & vbCrLf
    Next i
    lbl(1).Caption = strTmp$

End Sub
